//	0x04-0x226C2
/***********************************************************************/
/*  FILE        :_rotor.c                                              */
/*  DATE        :Mon, August 08, 2011                                  */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :R8C13                                                 */
/*  This file is generated by Renesas Project Generator (Ver.4.0).     */
/***********************************************************************/
#include "sfr_r813.h"

/* Anschlussbelegung ----------------------------------------------------
P4:5 - i - Impulse
P3:0 - i - li/re-tasten
P3:1 - o - links drehen
P3:2 - o - rechts drehen
P3:3 - i - Antennenumschaltung hor/ver
P3:7 - i - RxD11 - RS232
P1:0 - o - led 1
P1:1 - o - led 2
P1:2 - o - led 3
P1:3 - o - led 4
P1:4 - o - led 5
P1:5 - o - led 6
P1:6 - o - led 7
P1:7 - o - led 8
P0:0 - o - TxD11 - RS232
P0:1 - o - links drehen
P0:2 - o - rechts drehen
P0:3 - o - 
P0:4 - AN3 - 
P0:5 - AN2 - Antennenposition
P0:6 - AN1 - Poti
P0:7 - AN0 - Strom
*/ 
//zeiten ----------------------------------------------------------------------------------------
int zeit1=1/*wartezeit*/,zeit2=1000/*blinken*/, zeit3=0/*poti ruhig*/;
//anzeigen --------------------------------------------------------------------------------------
unsigned int anz_poti/*poti*/, anz_rotor/*rotor*/, anz_antenne/*antennrichtung*/;
char blink,anzeige=1; //multiplexer
//                              00   01   02   03   04   05   06   07   08   09   10   11   12   13   14   15   16   17   18   19   20   21   22   23   24   25   26   27   28   29   30   31   32   33   
unsigned char ledarray_l[35]={0x01,0x03,0x02,0x06,0x04,0x0c,0x08,0x18,0x10,0x30,0x20,0x60,0x40,0xc0,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x03,0x00};
unsigned char ledarray_h[35]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x03,0x02,0x06,0x04,0x0c,0x08,0x18,0x10,0x30,0x20,0x60,0x40,0xc0,0x80,0x80,0x00,0x00,0x00};
//adu -------------------------------------------------------------------------------------------
long adf[4];
char ad_kanal=0;
//rs232 -----------------------------------------------------------------------------------------
char empfang[11],nachricht=0,ptr=0;
//positionen ------------------------------------------------------------------------------------
long stand,winkel,ziel,offset=0,ist,tmp;
char li_re_taste=3;
char i,poti_neu=0,tast_stat=0,automat=0,lokal=1,reset=0;
char richtung=1, dreht=0, poti, antenne; //0: gegen, 1: mit Uhrzeiger
char text[30];  //zur konvertierung
			  
#define dr_li p3= 2;//p3_1 = 1
#define dr_re p3= 4;//p3_2 = 1
#define st_li p3_1 = 0
#define st_re p3_2 = 0
#define stopp  if(p3_3) p3=0; else p3=6;
#define led1_an p0_1=0
#define led1_aus p0_1=1
#define led2_an p0_2=0
#define led2_aus p0_2=1

#define blinkzeit 300

//Funktionen -------------------------------------------------------------
void warten (int zeitspanne) { zeit1 = zeitspanne; while(zeit1 != 0) asm("nop"); }
void senden (char byte)      { u1tb = byte; while(ti_u1c1 == 0); }

void konvert(int y, char *txt) {
	char i;
	for(i=1;i<5;i++)txt[i]=0x30;
	txt[5]=' ';txt[6]=' ';
	if (y<0) {y=-y; txt[0]='-';} else txt[0]=' ';
	while(y>=1000)   { y-=1000;    txt[1]++;}
	while(y>=100)    { y-=100;     txt[2]++;}
	while(y>=10)     { y-=10;      txt[3]++;}
	txt[4]+=y;
}

void drehung(int imp)
{   int ziel,z; char stop=0, t_start=0, ri=1;
	if(tast_stat > 0) t_start=1;
	if (imp==0) return;
	if (imp<0){ ri=0; imp=-imp;}
	richtung=ri;
	if (ri==1) {dr_re; ziel=stand+imp;} else {dr_li; ziel=stand-imp;}
	z=stand;
    warten(40); //20ms warten, dann messen
    dreht=1;
	while( (stand != ziel) && stop==0)
	{
		if( z!=stand)
		{
		 if(tast_stat == 2) {stop=1; tast_stat=1;}
		 if(tast_stat == 0 && t_start == 1) {stop=1;}
		 if(reset) stop=1;
	    }
		z=stand;
	}
	dreht=0;
	warten(50); //am ende 25ms warten, damit richtiger halt 
	stopp;
	automat=0;
}

void main(void)
{	// C-HW-Init ------------------------------------------------------------------------------
    prc0 = 1;           /* Protect off */
    cm13 = 1;           /* Xin Xout */
    cm15 = 1;           /* XCIN-XCOUT drive capacity select bit : HIGH */
    cm05 = 0;           /* Xin on */
    cm16 = 0;           /* Main clock = No division mode */
    cm17 = 0;
    cm06 = 0;           /* CM16 and CM17 enable */
    asm("nop");         /* Waiting for stable of oscillation */
    asm("nop");
    asm("nop");
    asm("nop");
	cm02 = 0;			/* nur Prozessorkern ohne Takt bei Wait*/
    ocd2 = 0;           /* Main clock change */
    prc0 = 0;           /* Protect on */

	//Timer X
	txs  = 0;
	txmr = 0;
	tcss = 0x00;		// Timer X f/1
	prex = 99;
	tx   = 99;			// 0,5ms Int Timer X
	ir_txic = 0;
	txic = 7;
	txs  = 1;
	prc2 = 1;
	// serielle kommunikation
	pd3_7 = 0;
	pu00  = 1;
	u1mr = 0x05;			// 8 Bit 1 Stopp k. Paritt interner Takt
	u1c0 = 0x00;			// fSio8
	u1c1 = 0x05;			// senden und empfangen erlaubt
	ucon = 0x22;			// pin auswahl
	u1brg = 129;		    // baudrate 9600 Bd

	s1ric = 7;				//uart1 intlevel=7  hchste
	txic  = 6;				//timer x intlevel=6
	
	
    prc1  = 1;	
	pm1   = 1;
	
	inostg = 1;				
	inoseg = 0;
	inten = 0x01; //int0 enable
	int0ic= 6; //fallende flanke level 6
	int0f = 3; //filter f/32

    asm( "FSET	I");	// Enable interrupt

	//Ports
	prc2= 1;				//erlaubt pd0 schreiben
	pd0 = 0x0F; 			//0IIIOOOO
	pd1 = 0xFF; 			//OOOOOOOO
	pd3 = 0x06;             //p32,p31:motor treiber  p30:tasten  p33:polarisation 
	pd4_5 = 0;
	//pu11 = 0;				//kein pull up
	pur0 = 0xFD;			//Port 1 Pull-up aktiv

	//ADU
	adcon0 = 0x49;			//AN1 einmalig ADC
	adcon1 = 0x28;
	adcon2 = 0x01;			//S&H

	// HW-Init ---------------------------------------------------------------------------------
	stopp;
	//nullstellung anfahren
	dr_li;
	warten(500);
	while(adf[0]>100);  //solange noch motorstrom fliet
	stopp;
	warten(500);
	drehung(4);
	stand=0;
	// HP-Schleife ----------------------------------------------------------------------------
	while(1){
		stopp;
		//aufgaben abarbeiten
		if (nachricht==1)
		{   nachricht=0;
			switch (empfang[0])
			{
			case 'r':   //rotieren
					    { automat=1;
						  tmp=1+(empfang[1]-0x30)*1000+(empfang[2]-0x30)*100+(empfang[3]-0x30)*10+empfang[4]-0x30;
						  if(tmp<  0) tmp=  0;
						  if(tmp>3815) tmp=3815;
						  ziel=(tmp*7030)/36000;
						  if(offset==0) drehung(ziel-stand);
						  else
						  { int ist=(stand+offset)%703;
						    int delta=ziel-ist;
							if((stand+delta)>703)
								drehung(delta-703);
							else
							{
							    if((stand+delta)<0)
								     drehung(703+delta);
								else
									 drehung(delta);
							}
						  }
						  break;}
			case 'p':   //rotieren ein impuls
					    { if(stand < 740)
						  {automat=1;
						  drehung(1);}
				          break;}
			case 'n':   //rotieren ein impuls
					    { if(stand > 0)
						  {automat=1;
						  drehung(-1);}
				          break;}
			case 'f':   //fernstuerung ein: keine lokale bedienung
					    { lokal=0;
				          break;}
			case 'l':   //fernsteurung aus: lokale bedienung
					    { lokal=1;
				          break;}
			case 'I':   //nullstellung anfahren
						{
						  reset=0;
						  dr_li;
						  warten(200);
						  while(adf[0] > 100);  //solange noch motorstrom fliet
						  stopp;
						  warten(200);
						  drehung(4);
						  stand=0;
						  empfang[0]=' ';
						  break;}
			case 'z':   //zustand ausgeben
						{ 
						  konvert(stand,   text);
						  konvert(offset,  text+6);
						  konvert((poti*703)/32,    text+12);
						  konvert(antenne, text+18);
						  text[24]=' ';
						  text[25]=0x30+li_re_taste+4*tast_stat;
						  text[27]=0x0d; text[26]=0x0a;
						  for(i=0;i<27;i++) {senden(text[i]);}
						  break;}
			case 'o':   //antennenoffset setzen
						{ tmp=1+(empfang[1]-0x30)*1000+(empfang[2]-0x30)*100+(empfang[3]-0x30)*10+empfang[4]-0x30;
						  if(tmp <   0) tmp=    0;
						  if(tmp >3600) tmp= 3600;
						  offset=(tmp*7030)/36000;
						  break;}
			default:  {break;} //position anzeigen
			}
			tmp=((stand+offset)*3600)/703;
			konvert(tmp%3600,text);
			text[5]=0x0d; text[6]=0x0a;
			for(i=0;i<7;i++) {senden(text[i]);}
		}
		// +/- taste bettgt
		if (tast_stat == 1)
		{
			poti_neu=0;
			if(li_re_taste==2)
			  drehung(740-stand);
			else
			  drehung(   -stand);
			tast_stat=0;
		}
		//neue poti_position anfahren
		if (poti_neu == 1)
		{
		   automat=1;
		   ziel=(poti*703)/32;
		   drehung(ziel-stand);
		   poti_neu=0;	
		}
		//darstellen
		warten(200);
	}
}
// Interrupts --------------------------------------------------------------------------------
#pragma interrupt zeit_int 
void zeit_int (void)
{	long a; int i; char b1, ta;
	if (zeit1) zeit1--;
	if (zeit2) zeit2--; else {zeit2=blinkzeit; blink=1-blink;}
	if (zeit3) zeit3--;  
	if (zeit3==1 && lokal){poti_neu=1;}
	//digitalfilter pt1
	adf[ad_kanal]=(7*adf[ad_kanal]+ad+4)/8;
	ad_kanal=(ad_kanal+1)%4;
	adcon0=ad_kanal;
	adst=1; //adc starten
	a=adf[1]/31;
	if(a!=poti) {zeit3=3000;}  //nach 1,5s nichtbettigung bernehmen
	poti=a;
	a=adf[2]/256;
	if(lokal && a!=antenne) offset=a*176;
	antenne=a;
	//led-positionen berechnen
	a=(stand+11)/22;
	anz_rotor  = 256*ledarray_h[a] + ledarray_l[a];
	a=(poti*703)/32+offset;
	if (a>703) a-=703;
	a=(a+11)/22;
	anz_poti   = 256*ledarray_h[a] + ledarray_l[a];
	a=stand+offset+11; if(a>703) a-=703;
	a/=22;
	anz_antenne= 256*ledarray_h[a] + ledarray_l[a];
	//anzeigen
	if(anz_rotor==anz_poti && anz_rotor==anz_antenne && blink==0) b1=0; else b1=1;
	anzeige++;
	switch(anzeige)
	{  
		case 1: { led2_aus;
				  if (blink && lokal) p1=0xff^(anz_poti/256);      else p1=0xff;
				  led1_an;
				break;}
		case 2: { led1_aus;
				  if (blink && lokal) p1=0xff^(anz_poti & 0x00ff); else p1=0xff;
				  led2_an;
				break;}
		case 3: { led2_aus;
				  if (b1) p1=0xff^(anz_rotor/256);        else p1=0xff;
				  led1_an;
				break;}
		case 4: { led1_aus;
				  if (b1) p1=0xff^(anz_rotor & 0x00ff);   else p1=0xff;
				  led2_an;
				break;}
		case 5: { led2_aus;
				  p1=0xff^(anz_antenne/256);
				  led1_an;
				break;}
		case 15:{ led1_aus;
				  p1=0xff^(anz_antenne & 0x00ff);
				  led2_an;
				break;}
		case 25:{ 
				  led2_aus;led1_aus;
				  p1=0;
				break;}
		case 26:{ anzeige=0;  
				  ta = 0x00 | !p3_0;
				  p1=1;
				  ta = (ta * 2) | p3_0;	
				  if (ta != li_re_taste)
				  {  tast_stat = 1;
				     if (dreht) tast_stat++;  }
				  li_re_taste = ta;
				  if (li_re_taste == 3)  tast_stat = 0;
				break;}
		default: break;
	}
}

#pragma interrupt empf_uart1 
void empf_uart1 (void)
{	if(u1rb>'@' || u1rb==' '){ptr=0;} //alle buchstaben als kommando
	empfang[ptr]=u1rb;
	ptr++;
	if(ptr>10) ptr=10;
	if(u1rb==0x0d || u1rb==0x0a) 
	{
		nachricht=1;
		if(empfang[0]=='I') reset=1;
	}
	u1tb = u1rb;
}

#pragma interrupt impulse_int 
void impulse_int (void)
{	if (dreht) {if (richtung==1) stand++; else stand--;}
	
}
